<script lang="ts">
  import { faExclamationTriangle, faSpinner } from "@fortawesome/free-solid-svg-icons";
  import { stringify } from "yaml";
  import { Accordion, AccordionItem, Alert } from "flowbite-svelte";
  import type { InputFormat } from "./deployment";
  import {GetCheckCheckByNameStore} from '$houdini'
  import Fa from "svelte-fa";
  import { getNotificationsContext } from "svelte-notifications";

  const { addNotification } = getNotificationsContext();

  export let input: InputFormat;
  export let validateExists = false;
  export let allExist = true;
  const role = 'event_admin';

  async function validateCheckExists(name: string) {
    console.log('checking name', name)
    // todo figure out why we can't query for type = adversarial here
    const response = await new GetCheckCheckByNameStore().fetch({ variables: {name}, metadata: {role} });
    const exists = !response.errors && !!response.data?.checks_checks.length
    if(!exists) {
      allExist = false;
      console.warn(`Check ${name} does not exist`)
      addNotification({
        text: `Check ${name} does not exist`,
        position: 'bottom-right',
        type: 'error',
        removeAfter: 3000
      })
    }
    return exists;
  }
  function getVars(key: string | undefined): Record<string, unknown> | null {
    return key ? input.vars[key as keyof typeof input.vars] || null : null;
  }
</script>

{#each input.checks as check}
  <Accordion>
    <AccordionItem>
      <div slot="header" class="grid grid-cols-5 gap-3 w-full text-center">
        <div>
          <!-- static width element for controls -->
          <div class="w-1/3 inline-block">
            {#if !getVars(check.vars)}
              <Fa icon={faExclamationTriangle} class="text-orange-500 inline" />
            {/if}
            {#if validateExists}
              {#await validateCheckExists(check.name)}
                <Fa spin icon={faSpinner} class="text-orange-500 inline" />
              {:then exists}
                {#if !exists}
                  <!-- todo add tooltips for what these mean-->
                  <Fa icon={faExclamationTriangle} class="text-red-500 inline" />
                {/if}
              {/await}
              {/if}
          </div>
          {check.display_order}
        </div>
        <div>
          <p>{check.name}</p>
          <p>{check.display_name}</p>
        </div>
        <div>
          <p>{check.subnet}</p>
          <p>{check.host}</p>
        </div>
        <div>{check.scoring_weight}</div>
        <div>{check.script}</div>
      </div>
      {#if getVars(check.vars)}
        <pre class="text-black">{stringify(getVars(check.vars))}</pre>
      {:else}
        <Alert color="orange">No Check Vars!</Alert>
      {/if}
    </AccordionItem>
  </Accordion>
{/each}
